/*
 * Colisao.cpp
 *
 *  Created on: Apr 15, 2010
 *      Author: alan
 */
class BoundBox{
	int pos_x1, pos_y1;//Canto superior esquerdo
	int pos_x2, pos_y2;//Canto inferior direito
	int dim_x,dim_y;//tamanho do lado em x e y
	int center_x,center_y;//centro do BoundBox

	public:
		BoundBox( int posX1,int posY1, int dimX,int dimY ){
			this->pos_x1 = posX1;
			this->pos_y1 = posY1;
			this->dim_x = dimX;
			this->dim_y = dimY;
			this->pos_x2 = this->pos_x1+this->dim_x;
			this->pos_y2 = this->pos_y1+this->dim_y;
			this->center_x = (this->pos_x1+this->pos_x2)/2;
			this->center_y = (this->pos_y1+this->pos_y2)/2;
		}
		void atualizarCentro(){
			this->pos_x2 = this->pos_x1+this->dim_x;
			this->pos_y2 = this->pos_y1+this->dim_y;
			this->center_x = (this->pos_x1+this->pos_x2)/2;
			this->center_y = (this->pos_y1+this->pos_y2)/2;
		}

		void setPosX1(int x){
			this->pos_x1 = x;
		}
		void setPosY1(int y){
			this->pos_y1 = y;
		}

		int getPosX1(){
			return this->pos_x1;
		}

		int getPosX2(){
				return this->pos_x2;
		}

			int getPosY1(){
					return this->pos_y1;
			}

			int getPosY2(){
					return this->pos_y2;
			}

			int getCenterX(){
				return this->center_x;
			}

			int getCenterY(){
					return this->center_y;
			}

			int getDimX(){
					return this->dim_x;
			}

			int getDimY(){
					return this->dim_y;
			}
			bool contemPonto( BoundBox *box, int x, int y){
				return ( x <= box->getCenterX() + box->getDimX()/2 && x >= box->getCenterX() - box->getDimX()/2 )&&
					   ( y >= box->getCenterY() - box->getDimY()/2 && y <= box->getCenterY() + box->getDimY()/2 );
			}
			bool detectarColisao( BoundBox *box1, BoundBox *box2 ){
				return contemPonto( box1, box2->getPosX1(), box2->getPosY1())||//Teste Lado direito box1
					   contemPonto( box1, box2->getPosX1(), box2->getPosY2())||//Teste Lado direito box1
					   contemPonto( box1, box2->getPosX2(), box2->getPosY1())||//Teste Lado esquerdo box1
					   contemPonto( box1, box2->getPosX2(), box2->getPosY2())||//Teste Lado esquerdo box1
					   contemPonto( box2, box1->getPosX1(), box1->getPosY1())||//Teste Lado direito box2
					   contemPonto( box2, box1->getPosX1(), box1->getPosY2())||//Teste Lado direito box2
					   contemPonto( box2, box1->getPosX2(), box1->getPosY1())||//Teste Lado esquerdo box2
					   contemPonto( box2, box1->getPosX2(), box1->getPosY2());//Teste Lado esquerdo box2
			}
			bool detectarColisaoDireita( BoundBox *box1, BoundBox *box2 ){
				return contemPonto( box1, box2->getPosX1(), box2->getPosY1())||//Teste Lado direito box1
					   contemPonto( box1, box2->getPosX1(), box2->getPosY2())||//Teste Lado direito box1
					   contemPonto( box2, box1->getPosX2(), box1->getPosY1())||//Teste Lado esquerdo box2
					   contemPonto( box2, box1->getPosX2(), box1->getPosY2());//Teste Lado esquerdo box2
			}
			bool detectarColisaoEsquerda( BoundBox *box1, BoundBox *box2 ){
				return 	contemPonto( box1, box2->getPosX2(), box2->getPosY1())||//Teste Lado esquerdo box1
					    contemPonto( box1, box2->getPosX2(), box2->getPosY2())||//Teste Lado esquerdo box1
					    contemPonto( box2, box1->getPosX1(), box1->getPosY1())||//Teste Lado direito box2
		   			    contemPonto( box2, box1->getPosX1(), box1->getPosY2());//Teste Lado direito box2
			}
//			bool detectarColisaoCimaBaixo( BoundBox *box1, BoundBox *box2 ){
//
//
//
//			}

//		int getPosX1();
//		int getPosX2();
//		int getPosY1();
//		int getPosY2();
//		int getCenterX();
//		int getCenterY();
//		int getDimX();
//		int getDimY();
//		bool contemPonto( BoundBox *box, int x, int y );
//		bool detectarColisao(  BoundBox *box1, BoundBox *box2 );
//
//};
//	int BoundBox::getPosX1(){
//		return this->pos_x1;
//	}
//
//	int BoundBox::getPosX2(){
//			return this->pos_x2;
//	}
//
//	int BoundBox::getPosY1(){
//			return this->pos_y1;
//	}
//
//	int BoundBox::getPosY2(){
//			return this->pos_y2;
//	}
//
//	int BoundBox::getCenterX(){
//		return this->center_x;
//	}
//
//	int BoundBox::getCenterY(){
//			return this->center_y;
//	}
//
//	int BoundBox::getDimX(){
//			return this->dim_x;
//	}
//
//	int BoundBox::getDimY(){
//			return this->dim_y;
//	}
//	bool BoundBox::contemPonto( BoundBox *box, int x, int y){
//		return ( x <= box->getCenterX() + box->getDimX()/2 && x >= box->getCenterX() - box->getDimX() )&&
//			   ( y <= box->getCenterY() + box->getDimY()/2 && y >= box->getCenterY() - box->getDimY() );
//	}
//
//	bool BoundBox::detectarColisao( BoundBox *box1, BoundBox *box2 ){
//		return contemPonto( box1, box2->getPosX1(), box2->getPosY1())||//Teste Lado direito
//			   contemPonto( box1, box2->getPosX1(), box2->getPosY2())||//Teste Lado direito
//			   contemPonto( box1, box2->getPosX2(), box2->getPosY1())||//Teste Lado esquerdo
//			   contemPonto( box1, box2->getPosX2(), box2->getPosY2());//Teste Lado esquerdo
//	}
};

