#include <allegro.h>
#include "Objetos.cpp"

class Impressao{
	//Bitmaps para Player1
	BITMAP *p1_walk_r[12];
	BITMAP *p1_walk_l[12];
	BITMAP *p1_stand_r[6];
	BITMAP *p2_stand_r;
	BITMAP *p1_stand_l[6];
	BITMAP *cenario1;
	BITMAP *helicoptero_l[11];
	BITMAP *helicoptero_r[11];
	BITMAP *helicoptero_stop;

	BITMAP *buffer;

	public: Impressao(){
		buffer = create_bitmap( 640,480 );

	}
	public: void imprimirTexto(char a[]){
        textprintf_ex(buffer, font, 0, 0, makecol(255,255,255), -1,a);

	}

	public: void imprimirScreen(){
		draw_sprite(screen, buffer, 0, 0);

	}
	public: void imprimirPlayer(int player, int tipoSprite, int sprite, int x, int y){
		//tipoSprite 1-andarDireita, 2- andarEsquerda, 3-paradoDireita,4-paradoEsquerda
		if ( player == 1 ){
			if( tipoSprite == 1 ){
				draw_sprite(buffer, p1_walk_r[sprite], x, y);
				//masked_blit(p1_walk_r[sprite], buffer, 0,0,0,0,x,y);
			}else if( tipoSprite == 2 ){
                draw_sprite(buffer, p1_walk_l[sprite], x, y);
				//masked_blit(p1_walk_l[sprite], buffer, 0,0,0,0,x,y);
			}if( tipoSprite == 3 ){
				draw_sprite(buffer, p1_stand_r[sprite], x, y);

			}if( tipoSprite == 4 ){
				draw_sprite(buffer, p1_stand_l[sprite], x, y);

			}

		}else if ( player == 2){
			draw_sprite(buffer, p2_stand_r, x, y);
		}


	}
	public: void imprimirCenario(int numero){
		if(numero == 1){
			draw_sprite(buffer, cenario1, 0, -50);
		}else if(numero == 2){

		}

	}
	public: void imprimirRetangulo(int x1, int y1, int x2, int y2){
		rect(buffer,x1,y1,x2,y2, makecol(0,255,0 ));
	}


	public: void imprimirHelicoptero(int tipoSprite,int sprite, int x, int y){
		//1 - parado , 2- direita, 3 -esquerda
		if( tipoSprite == 1){
			draw_sprite(buffer, helicoptero_stop, x, y);

		}else if( tipoSprite == 2){
			draw_sprite(buffer, helicoptero_r[sprite], x, y);

		}else if( tipoSprite == 3){
			draw_sprite(buffer, helicoptero_l[sprite], x, y);

		}

	}
	public: void carregarJogador1(){
		//Parado esquerda
		p1_stand_l[0] = load_bitmap("Player/player1standleft1.bmp",NULL);
		p1_stand_l[1] = load_bitmap("Player/player1standleft2.bmp",NULL);
		p1_stand_l[2] = load_bitmap("Player/player1standleft3.bmp",NULL);
		p1_stand_l[3] = load_bitmap("Player/player1standleft4.bmp",NULL);
		p1_stand_l[4] = load_bitmap("Player/player1standleft5.bmp",NULL);
		p1_stand_l[5] = load_bitmap("Player/player1standleft6.bmp",NULL);

		//Parado direita
		p1_stand_r[0] = load_bitmap("Player/player1standright1.bmp",NULL);
		p1_stand_r[1] = load_bitmap("Player/player1standright2.bmp",NULL);
		p1_stand_r[2] = load_bitmap("Player/player1standright3.bmp",NULL);
		p1_stand_r[3] = load_bitmap("Player/player1standright4.bmp",NULL);
		p1_stand_r[4] = load_bitmap("Player/player1standright5.bmp",NULL);
		p1_stand_r[5] = load_bitmap("Player/player1standright6.bmp",NULL);


		//Andar Direita
		p1_walk_r[0] = load_bitmap("Player/player1walkright1.bmp",NULL);
		p1_walk_r[1] = load_bitmap("Player/player1walkright2.bmp",NULL);
		p1_walk_r[2] = load_bitmap("Player/player1walkright3.bmp",NULL);
		p1_walk_r[3] = load_bitmap("Player/player1walkright4.bmp",NULL);
		p1_walk_r[4] = load_bitmap("Player/player1walkright5.bmp",NULL);
		p1_walk_r[5] = load_bitmap("Player/player1walkright6.bmp",NULL);
		p1_walk_r[6] = load_bitmap("Player/player1walkright7.bmp",NULL);
		p1_walk_r[7] = load_bitmap("Player/player1walkright8.bmp",NULL);
		p1_walk_r[8] = load_bitmap("Player/player1walkright9.bmp",NULL);
		p1_walk_r[9] = load_bitmap("Player/player1walkright10.bmp",NULL);
		p1_walk_r[10] = load_bitmap("Player/player1walkright11.bmp",NULL);
		p1_walk_r[11] = load_bitmap("Player/player1walkright12.bmp",NULL);


		//Andar esquerda
		p1_walk_l[0] = load_bitmap("Player/player1walkleft1.bmp",NULL);
		p1_walk_l[1] = load_bitmap("Player/player1walkleft2.bmp",NULL);
		p1_walk_l[2] = load_bitmap("Player/player1walkleft3.bmp",NULL);
		p1_walk_l[3] = load_bitmap("Player/player1walkleft4.bmp",NULL);
		p1_walk_l[4] = load_bitmap("Player/player1walkleft5.bmp",NULL);
		p1_walk_l[5] = load_bitmap("Player/player1walkleft6.bmp",NULL);
		p1_walk_l[6] = load_bitmap("Player/player1walkleft7.bmp",NULL);
		p1_walk_l[7] = load_bitmap("Player/player1walkleft8.bmp",NULL);
		p1_walk_l[8] = load_bitmap("Player/player1walkleft9.bmp",NULL);
		p1_walk_l[9] = load_bitmap("Player/player1walkleft10.bmp",NULL);
		p1_walk_l[10] = load_bitmap("Player/player1walkleft11.bmp",NULL);
		p1_walk_l[11] = load_bitmap("Player/player1walkleft12.bmp",NULL);


	}
	public: void carregarJogador2(){
		p2_stand_r = load_bitmap("Player/player2standright1.bmp",NULL);

	}

	public: void carregarHelicoptero(){
		helicoptero_stop = load_bitmap("Equipamentos/helicopteroparado.bmp",NULL);

		helicoptero_r[0] = load_bitmap("Equipamentos/helicoptero_r1.bmp",NULL);
		helicoptero_r[1] = load_bitmap("Equipamentos/helicoptero_r2.bmp",NULL);
		helicoptero_r[2] = load_bitmap("Equipamentos/helicoptero_r3.bmp",NULL);
		helicoptero_r[3] = load_bitmap("Equipamentos/helicoptero_r4.bmp",NULL);
		helicoptero_r[4] = load_bitmap("Equipamentos/helicoptero_r5.bmp",NULL);
		helicoptero_r[5] = load_bitmap("Equipamentos/helicoptero_r6.bmp",NULL);
		helicoptero_r[6] = load_bitmap("Equipamentos/helicoptero_r7.bmp",NULL);
		helicoptero_r[7] = load_bitmap("Equipamentos/helicoptero_r8.bmp",NULL);
		helicoptero_r[8] = load_bitmap("Equipamentos/helicoptero_r9.bmp",NULL);
		helicoptero_r[9] = load_bitmap("Equipamentos/helicoptero_r10.bmp",NULL);
		helicoptero_r[10] = load_bitmap("Equipamentos/helicoptero_r11.bmp",NULL);

		helicoptero_l[0] = load_bitmap("Equipamentos/helicoptero_l1.bmp",NULL);
		helicoptero_l[1] = load_bitmap("Equipamentos/helicoptero_l2.bmp",NULL);
		helicoptero_l[2] = load_bitmap("Equipamentos/helicoptero_l3.bmp",NULL);
		helicoptero_l[3] = load_bitmap("Equipamentos/helicoptero_l4.bmp",NULL);
		helicoptero_l[4] = load_bitmap("Equipamentos/helicoptero_l5.bmp",NULL);
		helicoptero_l[5] = load_bitmap("Equipamentos/helicoptero_l6.bmp",NULL);
		helicoptero_l[6] = load_bitmap("Equipamentos/helicoptero_l7.bmp",NULL);
		helicoptero_l[7] = load_bitmap("Equipamentos/helicoptero_l8.bmp",NULL);
		helicoptero_l[8] = load_bitmap("Equipamentos/helicoptero_l9.bmp",NULL);
		helicoptero_l[9] = load_bitmap("Equipamentos/helicoptero_l10.bmp",NULL);
		helicoptero_l[10] = load_bitmap("Equipamentos/helicoptero_l11.bmp",NULL);
	}

	public: void carregarCenario(){
		cenario1 = load_bitmap("Background/cenario1.bmp",NULL);

	}
	public: void destruir(){

	}
	public: void clearBuffer(){
	    clear(buffer);
	}
};
