#include "Impressao.cpp"
#include "Colisao.cpp"
#include "time.h"


class Menu{

public: Menu(){

	int teste = clock();
	int time = 0;
	Player *p1 = new Player(1,0,100,110);
	Player *p2 = new Player(2,0,200,110);
	Helicoptero *h1 = new Helicoptero(0,300,95);
	BoundBox *boxCenarioChao = new BoundBox(-4,154,680,50);
	BoundBox *boxCenarioTeto = new BoundBox(-4,-10,680,5);
	BoundBox *boxObstaculoDireita = new BoundBox( 450 , 60 , 30 , 400  );
	BoundBox *boxBoneco1 = new BoundBox(p1->getX(),p1->getY(),34,43);
	BoundBox *boxBoneco2 = new BoundBox(p2->getX(),p2->getY(),34,43);
	BoundBox *boxHelicoptero = new BoundBox(h1->getX(),h1->getY(),77,58);
	Impressao *impressao = new Impressao();
	impressao->carregarJogador1();
	impressao->carregarJogador2();
	impressao->carregarHelicoptero();

	impressao->imprimirPlayer(1,p1->getTipo(),p1->getSprite(),p1->getX(),p1->getY());
	impressao->imprimirScreen();
	impressao->carregarCenario();
	bool heli = false;
	bool tecla = false;
	int tipoCenario = 1;



	while( !key[KEY_ESC] ){
		if( clock()%(CLOCKS_PER_SEC/1000) == 0 ){//a cada 1 milisegundo soma time.
			time = time + 1;
		}

		vsync();
		rest(16);
		if(!heli){
			if( key[KEY_RIGHT] ){
				//if( !boxBoneco1->detectarColisao( boxBoneco1,boxBoneco2) ){
				p1->setX(p1->getX()+4);
				//}else{
				//impressao->imprimirTexto("Colisao");

				//}
				boxBoneco1->setPosX1(p1->getX());
				p1->setSprite(p1->getSprite()+1);
				p1->setTipo(1);
				tecla = true;

			}if( key[KEY_LEFT] ){
				p1->setSprite(p1->getSprite()+1);
				p1->setX(p1->getX()-4);
				boxBoneco1->setPosX1(p1->getX());
				p1->setTipo(2);
				tecla = true;

			}if( key[KEY_J] ){

				if(p1->getY() >= 110){
					p1->setY(p1->getY()-60);
					boxBoneco1->setPosY1(p1->getY());

				}
			}if( key[KEY_B] ){
				if(p1->getY() < 110){
					p1->setY(p1->getY()+60);
					boxBoneco1->setPosY1(p1->getY());

				}
			}if(  boxCenarioChao->detectarColisao( boxHelicoptero,boxBoneco1)&& key[KEY_H] )  {
				heli = true;
				//impressao->imprimirTexto("Colisao");


			}if( !tecla ){//Stand
				if(time > 2){

					if(p1->getSprite()>4){
						p1->setSprite(0);

					}

					if(p1->getTipo() == 1){
						p1->setTipo(3);

					}else if(p1->getTipo() == 2){
						p1->setTipo(4);

					}

					p1->setSprite(p1->getSprite()+1);
					time = 0;
				}

				//time++;
			}
			if(p1->getSprite() > 11){
				p1->setSprite(0);
			}
			tecla = false;
			if(!heli){
				boxBoneco1->atualizarCentro();

				impressao->imprimirCenario(1);
				impressao->imprimirPlayer(1,p1->getTipo(),p1->getSprite(),p1->getX(),p1->getY());
				//impressao->imprimirRetangulo(boxBoneco1->getPosX1(),boxBoneco1->getPosY1(), boxBoneco1->getPosX2(),boxBoneco1->getPosY2());
				//impressao->imprimirRetangulo(boxHelicoptero->getPosX1(),boxHelicoptero->getPosY1(), boxHelicoptero->getPosX2(),boxHelicoptero->getPosY2());
				//impressao->imprimirRetangulo(boxCenarioChao->getPosX1(),boxCenarioChao->getPosY1(), boxCenarioChao->getPosX2(),boxCenarioChao->getPosY2());
				//impressao->imprimirRetangulo(boxBoneco2->getPosX1(),boxBoneco2->getPosY1(), boxBoneco2->getPosX2(),boxBoneco2->getPosY2());
				impressao->imprimirHelicoptero(1,0,h1->getX(),h1->getY());
				//impressao->imprimirPlayer(2,p2->getTipo(),p2->getSprite(),p2->getX(),p2->getY());
				impressao->imprimirScreen();
				impressao->clearBuffer();
			}else{
				h1->setSprite(0);
				h1->setTipo(2);
				impressao->imprimirHelicoptero(h1->getTipo(),h1->getSprite(),h1->getX(),h1->getY());
				impressao->imprimirCenario(1);
				impressao->imprimirScreen();
				impressao->clearBuffer();
			}

		}else{//Dentro do helicoptero
			if( key[KEY_UP]){
				if( !boxCenarioChao->detectarColisao(  boxHelicoptero,boxCenarioTeto ) ){
					h1->setY(h1->getY()-3);
					boxHelicoptero->setPosY1(h1->getY());
				}

			}if( key[KEY_DOWN]){
				if( !boxCenarioChao->detectarColisao(  boxHelicoptero,boxCenarioChao ) ){

					h1->setY(h1->getY()+3);
					boxHelicoptero->setPosY1(h1->getY());
				}

			}if( key[KEY_RIGHT]){
				//if( !boxCenarioChao->detectarColisaoDireita( boxHelicoptero, boxObstaculoDireita )){
					h1->setX(h1->getX()+3);
					h1->setTipo(2);
					h1->setSprite(h1->getSprite()+1);
					boxHelicoptero->setPosX1(h1->getX());
				//}
			}if( key[KEY_LEFT]){
				//if( !boxCenarioChao->detectarColisaoEsquerda( boxHelicoptero, boxObstaculoDireita )){
					h1->setX(h1->getX()-3);
					h1->setTipo(3);
					h1->setSprite(h1->getSprite()+1);
					boxHelicoptero->setPosX1(h1->getX());
				//}

			}if( boxCenarioChao->detectarColisao( boxCenarioChao, boxHelicoptero ) && key[KEY_S] ){
				heli = false;
				p1->setY(110);
				boxBoneco1->setPosY1(p1->getY());


			}
			if( h1->getSprite() > 9){
				h1->setSprite(0);
			}
			if( time > 1 ){
				h1->setSprite(h1->getSprite()+1);

				time = 0;
			}
			//time++;

			p1->setX(h1->getX());
			boxBoneco1->setPosX1(p1->getX());
			if(heli){
				p1->setY(h1->getY());
				boxBoneco1->setPosY1(p1->getY());
			}
			boxBoneco1->atualizarCentro();
			boxHelicoptero->atualizarCentro();
			impressao->imprimirCenario(1);
			//impressao->imprimirRetangulo(boxCenarioChao->getPosX1(),boxCenarioChao->getPosY1(), boxCenarioChao->getPosX2(),boxCenarioChao->getPosY2());
			//impressao->imprimirRetangulo(boxHelicoptero->getPosX1(),boxHelicoptero->getPosY1(), boxHelicoptero->getPosX2(),boxHelicoptero->getPosY2());
			//impressao->imprimirRetangulo(boxObstaculoDireita->getPosX1(),boxObstaculoDireita->getPosY1(), boxObstaculoDireita->getPosX2(),boxObstaculoDireita->getPosY2());
			impressao->imprimirHelicoptero(h1->getTipo(),h1->getSprite(),h1->getX(),h1->getY());
			impressao->imprimirScreen();
			impressao->clearBuffer();

		}

	}

}
};



